# Duo, A crazy eights game.
# Copyright (C) 2009 The Duo developers.
#
# This file is part of Duo.
#
# Duo is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""
TODO
"""

import imp
import os
import sys
import zipimport

# Modules already imported.
# These are kept here because a call of load_module would reinitialize them.
# This is bad for dynamic class field, like _instance for the singleton model.
Imported = {}


def load_module(name, file, path, desc):
    if not path in Imported:
        try:
            module = imp.load_module(name, file, path, desc)
            Imported[path] = module
        finally:
            if file:
                file.close()
    else:
        module = Imported[path]

    try:
        path = module.__path__
    except Exception:
        pass

    return module, path


def zload_module(name):
    path = 'library.zip' + '/' + name
    if not path in Imported:
        loader = zipimport.zipimporter('library.zip')
        module = loader.load_module(name)
        Imported[path] = module

    else:
        module = Imported[path]

    return module


def import_recursively(module_name):
    """ FIXME: write this...
    """
    try:
        names = module_name.split('.')
        full_name = []
        path = None
        for name in names:
            full_name.append(name)
            try:
                file, path, desc = imp.find_module(name, path)
                module, path = load_module(name, file, path, desc)
            except ImportError:
                if hasattr(sys, 'frozen'):
                    # Try again, uzing zipimport.
                    # Documentation says to use fully dotted module name, but
                    # it seems it fails whereas file separator works ... ?
                    module = zload_module(os.path.sep.join(full_name))

        return module

    except Exception, err:
	message = _( 'import of %s failed (%s)' ) % (module_name, str(err))
        raise Exception(message)


def get_modules(package):
    """Return the set of modules available in the given package."""
    try:
        # Import the package first to prevent KeyError on sys.modules[].
        __import__(package)
        path = os.path.dirname(sys.modules[package].__file__)
        modules = [os.path.splitext(f)[0] for f in filter(
            lambda x: x.endswith('.pyc') or x.endswith('.py'), os.listdir(path))]
    except ImportError:
        modules = []
    return set([m for m in modules if m != '__init__'])
